	AREA iznimke, CODE, READONLY
	ENTRY
	; Primjer obrade IRQ, verzija 1

	; na adresi 0x18 nalazi se ova naredba
	B	OBR_IRQ

	; a ovaj dio koda nalazi se negdje drugdje u memoriji

	; prvo se omogucuje prihvacanje prekida	
	MRS R0, CPSR 			; procitaj CPSR u R0
	BIC R0, R0, #0x80	; na mjestu bita I se stavlja nula
	MSR CPSR_c, R0 		; i to se ponovo zapisuje u CPSR
									; da bi se omogucila obrada IRQ

	MOV r0, #1
PETLJA
	ADD r1, r1, #1
	CMP r0, #0
	BNE PETLJA

KRAJ
	MOV r0, #0x18			; angel_SWIreason_ReportException
	LDR r1, =0x20026 	; ADP_Stopped_ApplicationExit
	SWI 0x123456      	; ARM semihosting SWI

	; a ovdje je potprogram za obradu prekida
OBR_IRQ
	MOV R0, #0				; R0 se postavlja u nulu
	SUBS PC, R14, #4		; povratak iz iznimke
			
	END

