;Program za 64-bitno zbrajanje, verzija 1

	AREA add_64_v1, CODE, READWRITE

	ENTRY		
	
	LDR R0, AL		; niza 32 bita operanda A se ucitava u R0
	LDR R1, BL		; niza 32 bita operanda B se ucitava u R1
	ADDS R4, R0, R1	; izvodi se zbrajanje i postavljaju 
							; se zastavice (S)
	STR R4, REZL	; niza 32 bita rezultata se sprema 
							; u memoriju na REZL

	LDR R0, AH		; visa 32 bita operanda A se ucitava u R0
	LDR R1, BH		; visa 32 bita operanda B se ucitava u R1
	ADCS R4, R0, R1; izvodi se zbrajanje ukljucujuci prijenos
							; iz prethodne operacije i postavljaju 
							; se zastavice (S)
	STR R4, REZH	; visa 32 bita rezultata se sprema u
							; memoriju
	
kraj
	MOV R0, #0x18       ; angel_SWIreason_ReportException
	LDR R1, =0x20026    ; ADP_Stopped_ApplicationExit
	SWI 0x123456        ; ARM semihosting SWI
	
AL	DCD 0xFFFFFFFF		; operand A niza 32 bita
AH	DCD 0x40000000		; operand A visa 32 bita
BL	DCD 0x20000000		; operand B niza 32 bita
BH	DCD 0x66000000		; operand B visa 32 bita
REZL	SPACE 4			; rezultat niza 32 bita
REZH	SPACE 4			; rezultat visa 32 bita

	END

