; Program za 64-bitno zbrajanje, verzija 3

	AREA add_64_v3, CODE, READWRITE
	
ADDR EQU 0x8100			; adresa na kojoj se nalaze podatci
	
	ENTRY
	
	MOV R4, #ADDR   	; postavlja registar R4 na 8100(16)
				
	LDMIA R4!, {R5,R6,R7,R8};ucitavanje oba operanda
 								;koristenjem Load Multiple naredbe

	ADDS R5, R5, R7	; zbrajanje niza 32 bita 
								; s postavljanjem zastavica
	ADCS R6, R6, R8	; zbrajanje visa 32 bita i 
								; prijenosa iz prethodne operacije

	STMIA R4!, {R5,R6}	; spremanje rezultata

kraj				
	MOV R0, #0x18       ; angel_SWIreason_ReportException
	LDR R1, =0x20026    ; ADP_Stopped_ApplicationExit
	SWI 0x123456        ; ARM semihosting SWI

	END
	

