; Pretvara cijeli broj (integer) u ASCII hexadekadski broj, verzija 1
; UVJET ZADATKA: ulazni broj je u R5

	AREA itoa_v1, CODE, READWRITE

	ENTRY
	
ADDR EQU 0x8100			; adresa na koju se spremaju podatci
	
	MOV R4, #ADDR   	; postavlja registar R4 na pocetak podrucja za podatke
	MOV R6, #8		; brojac
	
PETLJA
	BL FUNC_ITOA
	STRB R0, [R4], #1	; sprema ASCII-znamenku u memoriju
	MOV R5, R5, LSR #4	; na najnize bitove stavlja se nova znamenka
	SUBS R6, R6, #1		; smanjuje se brojac prolaza
	BHI PETLJA		; ako je brojac veci od nule, ponavlja petlju

	MOV R0, #0x18		; angel_SWIreason_ReportException
	LDR R1, =0x20026 	; ADP_Stopped_ApplicationExit
	SWI 0x123456      	; ARM semihosting SWI

FUNC_ITOA			; R5=ulazni pod, R0=rezultat
	AND R0, R5, #0xf	; maskiranje bitova
	CMP R0, #0xA
	ADDLO R0, R0, #0x30	; ako je 0 <= x < 10, dodaj mu 0x30
	ADDHS R0, R0, #0x37	; u suprotnom, dodaj 0x37
	MOV PC,LR		; povratak iz potprograma
		
	END


