; Program za mnozenje 16-bitnih brojeva metodom pomaka, v. 3

	AREA mult_16_v3, CODE, READWRITE
	
ADDR EQU 0x8100				; adresa na kojoj se nalaze podatci
	ENTRY

	MOV R4, #ADDR   		;postavlja registar R4 adresu podataka
	LDRH R5, [R4], #2	;multiplikator se ucitava u R5
	LDRSH R6, [R4], #2	;multiplikand se ucitava u R6(predznak
									;sacuvan)
	MOV R7, #0				;cisti se registar za spremanje
									;rezultata (R7)
	
PETLJA	
	MOVS R5, R5, LSR #1;pomak multiplikatora za jedan bit
									;udesno, najnizi bit otici ce u C 
	ADDCS R7, R7, R6		;ako zastavica C=1, R6 se dodaje
									;privremenom rezultatu
	MOV R6, R6, LSL #1	;pomak R6 za jedan bit ulijevo
									;(priprema za moguci sljedeci korak)
	CMP R5, #0				;provjerava je li multiplikator
									;razlicit od nule
	BNE PETLJA				;ako je, ponavlja se petlja

	STR R7, [R4]			; spremanje rezultata			
kraj
	MOV R0, #0x18			; angel_SWIreason_ReportException
	LDR R1, =0x20026		; ADP_Stopped_ApplicationExit
	SWI 0x123456			; ARM semihosting SWI

	END 

